#include <png.h>


// PNG chunk
typedef struct
{
    char*     Name;
    uint32_t  Size;
    void*     Data;

    void*     Next;
} PNGChunk;


// PNG decode\encode context
typedef struct
{

    // libpng pointers
    png_structp pngPtr;
    png_infop infoPtr;

    // Opened for writing
    uint8_t Write;

    // Basic info
    uint32_t Width;
    uint32_t Height;
    uint32_t bitDepth;
    uint32_t colorType;

    // Array of transparent colors
    void* Trans;
    uint32_t transColor;

    // Data containing the PNG file
    void* Data;
    uint32_t dataOffset;
    uint32_t dataSize;

    // Linked list of chunks
    PNGChunk* Chunks;

} PNGContext;


void EXPORT pngClose(PNGContext* Ctx);
PNGContext* EXPORT pngOpen(void* Src, uint32_t srcLen);
PNGContext* EXPORT pngCreate();
uint32_t EXPORT pngAddChunk(PNGContext* PNG, const char* Name, const uint32_t Size, const void* Data);
uint32_t EXPORT pngRead(PNGContext* Ctx, void* Dest, void* destPal);
uint32_t EXPORT pngSave(PNGContext* PNG, const void* Src, void* Pal, const uint32_t numPal, const uint8_t compressLevel);