// RGB component splitting
#define RED(rgb)      (uint8_t) rgb
#define GREEN(rgb)    (uint8_t)(rgb >> 8)
#define BLUE(rgb)     (uint8_t)(rgb >> 16)
#define ALPHA(rgb)    (uint8_t)(rgb >> 24)

// RGB creation
#define RGB(r, g, b)     (uint32_t)r | (g << 8) | (b << 16)
#define RGBA(r, g, b, a) (uint32_t)r | (g << 8) | (b << 16) | (a << 24)
#define BGRA(r, g, b, a) (uint32_t)b | (g << 8) | (r << 16) | (a << 24)

// Byte swapping
#define SWAP2(Value)    (((Value) & 0xFF) << 8) | (Value >> 8)
#define SWAP4(Value)    (((Value >> 24) & 0xFF) | ((Value >> 8) & 0xFF00) | ((Value << 8) & 0xFF0000) | ((Value << 24) & 0xFF000000))


uint32_t	EXPORT createBGRA	(uint8_t R, uint8_t G, uint8_t B, uint8_t A);
uint32_t	EXPORT createRGBA	(uint8_t R, uint8_t G, uint8_t B, uint8_t A);
uint8_t		EXPORT getRed		(uint32_t Val);
uint8_t		EXPORT getGreen		(uint32_t Val);
uint8_t		EXPORT getBlue		(uint32_t Val);
uint32_t	EXPORT byteSwapInt	(uint32_t Value);
uint16_t	EXPORT byteSwapShort(uint16_t Value);
void		EXPORT freeMemory	(uint32_t* Mem);