VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBitplane"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


Public Width As Long
Public Height As Long
Public Planes As Long

Public ptrBitplane As Long


' Create new bitplane
Public Function Create(ByVal nWidth As Long, nHeight As Long, ByVal nPlanes As Long)

    bitplaneDestroy ptrBitplane
    
    ptrBitplane = bitplaneCreate(nWidth, nHeight, nPlanes)
    Width = nWidth
    Height = nHeight
    Planes = nPlanes
    
    Create = True
    
End Function


' Load amiga (16x?x4) sprite
Public Function loadAmigaSprite(ByRef Bits As clsBitStream, ByVal nWidth As Long, ByVal nHeight As Long) As Boolean

    bitplaneDestroy ptrBitplane
    
    ptrBitplane = bitplaneLoadAmigaSprite(Bits.ptrBitStream, nWidth, nHeight)
    Width = nWidth
    Height = nHeight
    Planes = 4
    
    loadAmigaSprite = True

End Function


' Load planar (bitplane per row) sprite
Public Function loadPlanar(ByRef Bits As clsBitStream, ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long) As Boolean

    bitplaneDestroy ptrBitplane
    
    ptrBitplane = bitplaneLoadPlanar(Bits.ptrBitStream, nWidth, nHeight, nPlanes)
    Width = nWidth
    Height = nHeight
    Planes = nPlanes
    
    loadPlanar = True

End Function


' Load chunky (bitplane per image) sprite
Public Function loadChunky(ByRef Bits As clsBitStream, ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long) As Boolean

    bitplaneDestroy ptrBitplane
    
    ptrBitplane = bitplaneLoadChunky(Bits.ptrBitStream, nWidth, nHeight, nPlanes)
    Width = nWidth
    Height = nHeight
    Planes = nPlanes
    
    loadChunky = True

End Function


' Convert this bitplane into a surface using a palette
Public Function toSurface(ByRef Mask As clsBitplane, ByVal ptrPal As Long, ByVal transColor As Long, ByVal Mode As Long) As clsSurface

    Dim ptrSurface As Long
    Dim maskPtr As Long
    
    
    If ptrBitplane = 0 Then Exit Function
    
    ' Masking
    If Mask Is Nothing Then
        maskPtr = 0
    Else
        maskPtr = Mask.ptrBitplane
    End If
    
    ptrSurface = bitplaneToSurface(ptrBitplane, maskPtr, ptrPal, transColor, Mode)
    If ptrSurface = 0 Then Exit Function
    
    Set toSurface = New clsSurface
    toSurface.ptrSurface = ptrSurface
    toSurface.Width = surfaceGetWidth(ptrSurface)
    toSurface.Height = surfaceGetHeight(ptrSurface)

End Function


Private Sub Class_Terminate()

    bitplaneDestroy ptrBitplane
    
    ptrBitplane = 0

End Sub
