VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUtils"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


' Font structure
Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(31) As Byte
End Type

' Common controls init data
Private Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type

' ShellExecuteEx structure
' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/shellcc/platform/shell/reference/structures/shellexecuteinfo.asp
Private Type SHELLEXECUTEINFO
    cbSize As Long
    fMask As Long
    hWnd As Long
    lpVerb As String
    lpFile As String
    lpParameters As String
    lpDirectory As String
    nShow As Long
    hInstApp As Long
    
    ' Optional fields
    lpIDList As Long
    lpClass As String
    hkeyClass As Long
    dwHotKey As Long
    hIcon As Long
    hProcess As Long
End Type


' API calls
Private Declare Function InitCommonControlsEx Lib "comctl32" (iCCEx As tagInitCommonControlsEx) As Boolean
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uiAction As Long, ByVal uiParam As Long, ByVal ptrParam As Long, ByVal fWinIni As Long) As Long
Private Declare Function ShellExecuteEx Lib "shell32" Alias "ShellExecuteExA" (ByRef execInfo As SHELLEXECUTEINFO) As Boolean
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal ptrDest As Long, ByVal ptrSource As Long, ByVal Bytes As Long)


' Return long value of a string
Public Function stringToLong(ByVal Data As String) As Long

    Dim A As Long
    Dim Temp As Long
    
    
    For A = 0 To 3
        CopyMemory VarPtr(Temp) + A, StrPtr(Data) + A * 2, 1
    Next A
    
    stringToLong = Temp

End Function


' Execute something using the Windows shell
Public Sub shellOpen(ByVal fileName As String)

    Dim shellInf As SHELLEXECUTEINFO
    
    
    With shellInf
        .cbSize = Len(shellInf)
        .lpFile = fileName
        .lpDirectory = stripFile(fileName)
        .nShow = 5
    End With
    
    ShellExecuteEx shellInf

End Sub


' Get the default system font and apply it to all controls in this program
Public Function applyDefaultSystemFont() As Boolean

    Dim useFont As LOGFONT
    Dim myForm As Form
    Dim myControl As Control
    Dim oldFont As StdFont

    
    ' Get default system font
    If SystemParametersInfo(31, LenB(useFont), VarPtr(useFont), 0) = 0 Then Exit Function
    
    ' Apply font object to all controls on all loaded forms
    For Each myForm In Forms
        For Each myControl In myForm.Controls
            
            ' Only apply font to objects that need it
            Select Case TypeName(myControl)
                Case "CommandButton", "Label", "TextBox", "ComboBox", "CheckBox", "ctlFancyList", "OptionButton", "PictureBox", "ListBox", "DTPicker"
                    
                    Set oldFont = myControl.Font
                
                    ' Create new font object for each control to keep specific size and styles
                    Set myControl.Font = New StdFont
                    With myControl.Font
                        .Name = StrConv(useFont.lfFaceName, vbUnicode)
                        .Charset = useFont.lfCharSet
                        .Bold = oldFont.Bold
                        .Italic = oldFont.Italic
                        .Underline = oldFont.Underline
                        .Size = oldFont.Size
                    End With

            End Select
            
        Next myControl
    Next myForm
    
    
    applyDefaultSystemFont = True

End Function


' Initialise common controls for themed look
Public Function initCommonControls() As Boolean
   
   Dim iCCEx As tagInitCommonControlsEx
   
   On Error Resume Next
      
   
   With iCCEx
       .lngSize = LenB(iCCEx)
       .lngICC = &H200
   End With
   
   InitCommonControlsEx iCCEx
   initCommonControls = (Err.Number = 0)
   
   On Error GoTo 0
   
End Function


' Fill a combobox with fonts from the App.Path\fonts folder
Public Sub comboFonts(ByRef cBox As ComboBox, ByVal Default As String)

    Dim mFile As File
    Dim fName As String
    
    
    cBox.Clear
    For Each mFile In FS.GetFolder(App.Path & "\fonts").Files
        fName = LCase$(FS.GetBaseName(mFile.Name))
        cBox.AddItem fName
        If fName = Default Then cBox.ListIndex = cBox.ListCount - 1
    Next mFile

End Sub


' Fill a combobox with valid configurations from the App.Path\config folder
Public Sub comboConfigs(ByRef cBox As ComboBox, ByVal Default As String)

    Dim mFile As File
    Dim fName As String
    
    
    cBox.Clear
    For Each mFile In FS.GetFolder(App.Path & "\config").Files
        fName = LCase$(FS.GetBaseName(mFile.Name))
        If fName <> "common" And fName <> "unknown" Then
            cBox.AddItem fName
            If fName = Default Then cBox.ListIndex = cBox.ListCount - 1
        End If
    Next mFile

End Sub


' Fill a combobox with valid level files from the Superfrog data folder
Public Sub comboLevels(ByRef cBox As ComboBox, ByVal Path As String, ByVal Default As String)

    Dim mFile As File
    Dim fName As String
    
    
    cBox.Clear
    For Each mFile In FS.GetFolder(Path).Files
        fName = UCase$(mFile.Name)
        If Left$(fName, 1) = "L" And Mid$(fName, 3, 2) = "MA" Then
            cBox.AddItem fName
            If fName = Default Then cBox.ListIndex = cBox.ListCount - 1
        End If
    Next mFile

End Sub


' Get address of a function through AddressOf
Public Function getAddressOfFunction(Address As Long) As Long

    getAddressOfFunction = Address
  
End Function


' Strip the path from a filename
Public Function stripFile(ByVal Path As String) As String

    If InStr(Path, "\") <> 0 Then
        stripFile = Mid$(Path, 1, InStrRev(Path, "\") - 1)
    Else
        stripFile = Path
    End If

End Function


' Strip null cahracters from a string
Public Function stripNull(ByVal fixedString As String) As String

    Dim A As Long
    
    
    For A = Len(fixedString) To 1 Step -1
        If Mid$(fixedString, A, 1) <> vbNullChar Then
            stripNull = Left$(fixedString, A)
            Exit Function
        End If
    Next A
    
    stripNull = fixedString
    
End Function


' Pad a string with characters up to a certain number
Public Function padRight(ByVal inString As String, ByVal padChar As String, targetLength As Long) As String

    If Len(inString) < targetLength Then
        padRight = inString & String(targetLength - Len(inString), padChar)
    
    Else
        padRight = inString
        
    End If

End Function
