VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWorld"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


Public Index As Long

Private ptrPal As Long
Public Pal As clsPalette

Private Levels() As clsLevel
Public levelCount As Integer

Private ptrCollision As Long

Private ptrTileGFX As Long
Public Tiles As clsTileSet


Public Function getLevel(ByVal Index As Long) As clsLevel

    If Index < 0 And Index > levelCount - 1 Then Exit Function
    
    Set getLevel = Levels(Index)

End Function


' Load an entire world from a bitstream
Public Function loadFrom(ByRef Bits() As clsBitStream, ByVal wIndex As Long, ByRef spriteDict As Dictionary, ByRef mainDict As Dictionary) As Boolean

    Dim A As Long
    Dim Offset As Long
    Dim Offsets() As Long
    Dim tileCount As Long
    
    Dim nDict As Dictionary
    Dim lSt As String
        
    
    Index = wIndex
    
    ' World header
    ptrTileGFX = Bits(0).getLong - DATAOFFSET
    ptrCollision = Bits(0).getLong - DATAOFFSET
    ptrPal = Bits(0).getLong - DATAOFFSET
    Bits(0).skipBytes 8
    levelCount = Bits(0).getInteger

    ' Levels
    ReDim Levels(levelCount - 1)
    For A = 0 To levelCount - 1
        Set Levels(A) = New clsLevel
        Set Levels(A).World = Me
        Levels(A).ptrHeader = Bits(0).getLong - DATAOFFSET
    Next A

    For A = 0 To levelCount - 1
        Bits(0).seekTo Levels(A).ptrHeader
        
        ' Hack for world 3
        ' The actual game loads the sublevel over previous level data,
        ' which is circumvented here for the other worlds by assuming
        ' map data is at the start of the second bitstream parameter.
        ' World 3 level 2's map data does not start immediately but
        ' is preceded by some other data.
        If Index = 2 And A = 1 Then
            Offset = 19620
        Else
            Offset = 0
        End If
        
        Levels(A).loadFrom A, Bits(0), Bits(A), Offset
    Next A

    
    ' Palette
    Bits(0).seekTo ptrPal
    Set Pal = New clsPalette
    Pal.loadFrom Bits(0), 16
    
    
    ' Tile GFX
    Bits(0).seekTo ptrTileGFX
    
    ' First offset also indicates how many bytes of offsets, thus the number of tiles
    tileCount = Bits(0).getLong / 4
    
    ' We ignore the actual offsets as they are not needed
    Bits(0).seekTo ptrTileGFX + (tileCount * 4)
    Set Tiles = New clsTileSet
    Tiles.loadFromBits Bits(0), TILESIZE, tileCount, Pal
    
    
    ' Tile collision data
    Bits(0).seekTo ptrCollision
    Tiles.loadCollisionFrom Bits(0)
    
    
    ' Sprite configurations
    For A = 0 To levelCount - 1
        ' Global
        Levels(A).loadSprites mainDict
        
        ' Shared world
        Set nDict = spriteDict("shared")
        Levels(A).loadSprites nDict
        
        ' Level
        lSt = "L" & wIndex + 1 & "-" & A + 1
        If spriteDict.Exists(lSt) Then
            Set nDict = spriteDict(lSt)
            Levels(A).loadSprites nDict
        End If
    Next A
    
End Function
